--- hat/script/confhc-hat	Mon Oct 31 21:26:52 2005
+++ hat-2.04/script/confhc-hat	Mon Mar 14 20:07:54 2005
@@ -56,7 +56,7 @@
 ghcsym () {
   echo __GLASGOW_HASKELL__ >ghcsym.hs;
   $1 -E -cpp -optP-P ghcsym.hs -o ghcsym.out;
-  grep -v '^#' ghcsym.out | grep -v '^$' > $2
+  grep -e '^[0-9]*$' ghcsym.out > $2
   rm -f ghcsym.hs ghcsym.out;
 }
 